* tests/synclines.at (AT_SYNCLINES_COMPILE): New.

(AT_TEST_SYNCLINE): Adjust to unusual GCC outputs.
Reported by R Blake <blakers@mac.com>.
This commit is contained in:
Akim Demaille
2002-07-09 10:06:20 +00:00
parent c76e14da4b
commit 865b9df14c
3 changed files with 48 additions and 14 deletions

View File

@@ -1,3 +1,9 @@
2002-07-09 Akim Demaille <akim@epita.fr>
* tests/synclines.at (AT_SYNCLINES_COMPILE): New.
(AT_TEST_SYNCLINE): Adjust to unusual GCC outputs.
Reported by R Blake <blakers@mac.com>.
2002-07-09 Akim Demaille <akim@epita.fr>
* data/yacc.c: Output the copyright notive in the header.

1
THANKS
View File

@@ -41,6 +41,7 @@ Paul Eggert eggert@twinsun.com
Per Allansson per@appgate.com
Peter Hámorský hamo@upjs.sk
Piotr Gackiewicz gacek@intertel.com.pl
R Blake blakers@mac.com
Raja R Harinath harinath@cs.umn.edu
Richard Stallman rms@gnu.org
Robert Anisko anisko_r@epita.fr

View File

@@ -18,6 +18,22 @@
AT_BANNER([[User Actions.]])
# AT_SYNCLINES_COMPILE(FILE)
# --------------------------
# Compile FILE expecting an error, and save in the file stdout the normalized
# output.
m4_define([AT_SYNCLINES_COMPILE],
[AT_CHECK([$CC $CFLAGS $CPPFLAGS $1 -c], 1, [], [stderr])
# In case GCC displays column information, strip it down.
#
# input.y:4:2: #error "4" or input.y:4.2: #error "4"
# =>
# input.y:4: #error "4"
#
AT_CHECK([[sed 's/^\([^:]*:[^:.]*\)[.:][^:]*:\(.*\)$/\1:\2/' stderr]], 0, [stdout])
])
# AT_TEST_SYNCLINE(TITLE, INPUT, ERROR-MSG)
# -----------------------------------------
# Check that compiling the parser produced from INPUT cause GCC
@@ -25,23 +41,34 @@ AT_BANNER([[User Actions.]])
m4_define([AT_TEST_SYNCLINE],
[AT_SETUP([$1])
# I'm not sure I can find a generic scheme to check the location
# of an error, so we keep this for GCC only.
AT_CHECK([test "$GCC" = yes || exit 77])
# It seems impossible to find a generic scheme to check the location
# of an error. Even requiring GCC is not sufficient, since for instance
# the version modified by Apple:
#
# | Reading specs from /usr/libexec/gcc/darwin/ppc/2.95.2/specs
# | Apple Computer, Inc. version gcc-934.3, based on gcc version 2.95.2
# | 19991024 (release) configure:2124: $? = 0
#
# instead of:
#
# | input.y:2: #error "2"
#
# it reports:
#
# | input.y:2: "2"
# | cpp-precomp: warning: errors during smart preprocessing, retrying in basic mode
AT_DATA([[input.y]],
[$2])
AT_DATA([syncline.c],
[[#error "1"
]])
AT_SYNCLINES_COMPILE([syncline.c])
AT_CHECK([[test "`cat stdout`" = 'syncline.c:1: @%:@error "1"' || exit 77]])
AT_DATA([[input.y]], [$2])
AT_CHECK([bison input.y -o input.c])
AT_CHECK([$CC $CFLAGS $CPPFLAGS input.c -c], 1, [], [stderr])
# In case GCC displays column information, strip it down.
#
# input.y:4:2: #error "4" or input.y:4.2: #error "4"
# =>
# input.y:4: #error "4"
#
AT_CHECK([[sed 's/^\([^:]*:[^:.]*\)[.:][^:]*:\(.*\)$/\1:\2/' stderr]],
0, [$3])
AT_SYNCLINES_COMPILE([input.c])
AT_CHECK([cat stdout], 0, [$3])
AT_CLEANUP
])